/* au file ôʬ
 * shige
 * 05/29 2000
 * sndio.c
 *
 * $Id: sndio.c,v 1.4 2000-11-03 19:58:57+09 shige Exp $
 */
/* 05/29 200
 * 1)	 auconn.c ˤäΤʬΥ
 * 2)	Τˡؿλͤľ
 */
#ifndef __SNDIO_C__
#define __SNDIO_C__

#include "sndio.h"

/* #define DEBUG1 */
/* #define DEBUG2 */

/* au file  header μ */
int getSndheader(FILE *file,Snddata *Snd)
{
    fseek(file,0,SEEK_SET);
    if(read4bytetoi(file,&(Snd->magic))<0
       || read4bytetoi(file,&(Snd->hlen))<0
       || read4bytetoi(file,&(Snd->datalen))<0
       || read4bytetoi(file,&(Snd->fmcode))<0
       || read4bytetoi(file,&(Snd->smplrate))<0
       || read4bytetoi(file,&(Snd->channel))<0)
      return Err_read4bytetoi;
    Snd->str=NULL;
#ifdef DEBUG1
    fprintf(stderr,"(magic,hlen,datalen,fmcode,smplrate,channel)=");
    fprintf(stderr,"(%d,%d,%d,%d,%d,%d)\n",Snd->magic,Snd->hlen,
	    Snd->datalen,Snd->fmcode,Snd->smplrate,Snd->channel);
#endif /* DEBUG1 */
    return No_err;
}

/* Snd header  */
int chSndheader(Snddata *Snd1,Snddata *Snd2)
{
    if(Snd1->magic != Snd2->magic) return Err_diffmagic;
    if(Snd1->fmcode != Snd2->fmcode) return Err_diffmcode;
    if(Snd1->smplrate != Snd2->smplrate) return Err_diffsmplrate;
    if(Snd1->channel != Snd2->channel) return Err_diffchannel;
    return No_err;
}

/* Snd[] Ĥʤ file  header ν */
void putallheader(FILE *file,Snddata *Snd,int N)
{
    int j;
    int datalen=0;

    writeito4byte(file,Snd[0].magic);
    writeito4byte(file,32);
    for(j=1;j<=N;j++) datalen+=Snd[j-1].datalen;
    writeito4byte(file,datalen);
    writeito4byte(file,Snd[0].fmcode);
    writeito4byte(file,Snd[0].smplrate);
    writeito4byte(file,Snd[0].channel);
    writeito4byte(file,0);
    writeito4byte(file,0);
}

/* Ĺ */
void putallheader2(FILE *file,Snddata *Snd,int N,int len,int addsp)
{
    int j;
    int datalen=0;

    writeito4byte(file,Snd[0].magic);
    writeito4byte(file,32);
    for(j=1;j<=N;j++)
      datalen+=(len>0 && (Snd[j-1].datalen>=len ||addsp))?len:Snd[j-1].datalen;
    writeito4byte(file,datalen);
    writeito4byte(file,Snd[0].fmcode);
    writeito4byte(file,Snd[0].smplrate);
    writeito4byte(file,Snd[0].channel);
    writeito4byte(file,0);
    writeito4byte(file,0);
}

#endif /* __SNDIO_C__ */
