/* AIFF file ôʬΥإåե
 * shige
 * 10/29 2000
 * aiffio.h
 * 
 * $Id: aiffio.h,v 1.5 2000-11-04 01:32:21+09 shige Exp $
 */
#ifndef __AIFFIO_H__
#define __AIFFIO_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "chunk.h"
#include "error.h"
#include "fileio.h"
#include "ToFromIEEE.h"

#ifdef __AIFFIO_C__
# define AIFFCOMMCHUNKSIZE 18
#endif /* __AIFFIO_C__ */

#define IEEEExtendedBytes 10

typedef struct {
    double x;
    char s[IEEEExtendedBytes];
} Extended;

typedef struct {
    short int channel;	/* 1,2,...,6 */
    long int flames;	/* number of blocks = datalen/flamesize */
    short int bitpersmpl;	/* 8,16,24,32 */
    Extended smplrate;	/* frames/sec */
    short int flamesize;	/* channel*bitpersmpl/8 */
    long int hlen;	/* data start offset */
    long int datalen;	/* data size (byte) */
} AIFFdata;

#define AIFF8NULL (0xff)
#define AIFF16NULL (0xfff8)

#ifdef __AIFFIO_C__
# define EXTERN_AIFFIO 
#else
# define EXTERN_AIFFIO extern 
#endif

EXTERN_AIFFIO int getAIFFheader(FILE *file,AIFFdata *ad);
EXTERN_AIFFIO int getAIFFinfo(FILE *file,AIFFdata *ad,Chunk *Ch);
EXTERN_AIFFIO int chAIFFheader(AIFFdata *ad1,AIFFdata *ad2);
EXTERN_AIFFIO void putallAIFFheader(FILE *file,AIFFdata *ad,int N);
EXTERN_AIFFIO void putallAIFFheader2(FILE *file,AIFFdata *ad,int N,int len,
				     int addsp);
EXTERN_AIFFIO int readAIFFExtended(FILE *file,Extended *Ex);
EXTERN_AIFFIO int writeAIFFExtended(FILE *file,Extended *Ex);
EXTERN_AIFFIO int chAIFFExtended(Extended *Ex1,Extended *Ex2);

#endif /* __AIFFIO_H__ */
